float px; 
float py;
float x; 
float y;
float cx; 
float cy;

float red = 100;
float green = 100;
float blue = 100;


void setup() {
  size(480, 480);  
  background(0);
  stroke(255);  
  strokeWeight(1);  

  cx = 0.5 * width; 
  cy = 0.5 * height;
  px = cx; 
  py = cy;  
  x = cx; 
  y = cy;
}

void draw() {
  if (mousePressed) {
    line(cx, cy, mouseX, mouseY);
  }
}

void mousePressed() {

  cx = mouseX;
  cy = mouseY;

  fill(255, 0, 0);
  ellipse(cx, cy, 5, 5);
}

void mouseReleased() {

  float D = dist(cx, cy, mouseX, mouseY);

  px = cx; 
  py = cy;
  x = cx; 
  y = cy;

  for (int i=0; i<30000; i++) {

    float n = 5;
    x = x + random(2*n) - n;
    y = y + random(2*n) - n;

    red = red + random(2*n) - n;
    blue = blue + random(2*n) - n;
    green = green + random(2*n) - n;

    red = constrain(red, 0, 255);
    blue = constrain(blue, 0, 255);
    green = constrain(green, 0, 255);

    color col = color(red, green, blue);
    stroke(col);    

    if (dist(x, y, cx, cy)>D) {
      x = px;  
      y = py;
    }
    line(px, py, x, y);
    px = x; 
    py = y;
  }
}
